<script setup>
// TODO: Move file explorer in it's own component
import LayoutCategorySection from '@/layout/LayoutCategorySection.vue'
import LayoutCategoryCentered from '@/layout/LayoutCategoryCentered.vue'
import FileCard from '@/component/FileCard.vue'
import FileRow from '@/component/FileRow.vue'
import CategoryMessage from '@/component/CategoryMessage.vue'
import FileModal from '@/component/FileModal.vue'
import FileContextMenu from '@/component/FileContextMenu.vue'
import { Icon } from '@iconify/vue'
import { useBlocStore } from '@/store/bloc'
import { useFileModal } from '@/store/file-modal'
import { useRoute } from 'vue-router'
import { computed } from 'vue'

const blocStore = useBlocStore()
const fileModalStore = useFileModal()
const route = useRoute()

const isContentInContext = computed(() => {
  return fileModalStore.modal[route.name] !== undefined
})

const handleShowModalRename = (event, bid) => {
  fileModalStore.showFileModal(route.name, {
    state: 'rename',
    bid: bid,
    title: 'Rename'
  })
}

const handleShowModalMove = (event, bid) => {
  fileModalStore.showFileModal(route.name, {
    state: 'move',
    bid: bid,
    title: 'Move'
  })
}

const handleShowModalDelete = (event, bid) => {
  fileModalStore.showFileModal(route.name, {
    state: 'delete',
    bid: bid,
    title: 'Delete'
  })
}

const handleModalClose = () => {
  fileModalStore.hideFileModal(route.name)
}
</script>

<template>
  <FileModal
    v-if="isContentInContext"
    :context="route.name"
    @event-close="handleModalClose"
  >
  </FileModal>

  <FileContextMenu
    @event-rename="handleShowModalRename"
    @event-move="handleShowModalMove"
    @event-delete="handleShowModalDelete"
  />

  <LayoutCategoryCentered v-if="blocStore.blocsCount === 0">
    <CategoryMessage
      message="Transfer your first file"
    >
      <template #icon>
        <Icon icon="mdi:cloud-upload" width="128px" height="128px" />
      </template>
    </CategoryMessage>
  </LayoutCategoryCentered>

  <LayoutCategorySection v-if="blocStore.blocsCount > 0" title="Suggestions">
    <div class="card-list-scroll">
      <FileCard
        v-for="file in blocStore.files"
        :key="file.id"
        :properties="file"
      />
    </div>
  </LayoutCategorySection>

  <div class="table-wrapper" v-if="blocStore.blocsCount > 0">
    <table>
      <thead>
      <tr>
        <th>Name</th>
        <th>Size</th>
        <th>Last modification</th>
        <th>Shared with</th>
      </tr>
      </thead>
      <tbody>
      <FileRow
          v-for="bloc in blocStore.blocs"
          :key="bloc.id"
          :properties="bloc"
        />
      </tbody>
    </table>
  </div>
</template>

<style lang="scss" scoped>
  .v-category-file {
    position: relative;
    display: flex;
    flex-direction: column;
    padding-bottom: 1rem;
    height: 100%;
    background-color: red;
  }

  .card-list-scroll {
    position: absolute;
    display: flex;
    gap: 2rem;
    left: -2rem;
    right: -2rem;
    top: 0;
    bottom: 0;

    overflow-x: scroll;
    padding: 0 2rem;
    /* Hide scroll bar */
    -ms-overflow-style: none;   /* IE and Edge */
    scrollbar-width: none;      /* Firefox */
    //scrollbar-width: thin;
    //scrollbar-color: $complementary-white-25 transparent;
    &::-webkit-scrollbar {      /* Chrome */
      display: none;
    }
  }

  .table-wrapper {
    overflow-y: scroll;
    display: flex;
    flex-direction: column;
    scrollbar-width: thin;
    scrollbar-color: $complementary-white-25 transparent;
    // flex-grow : 1;
    height: 100%;
    &::-webkit-scrollbar {
      width: 6px; /* width of the entire scrollbar */
    }
    &::-webkit-scrollbar-track {
      background: transparent; /* color of the tracking area */
    }
    &::-webkit-scrollbar-thumb {
      background-color: $complementary-white-25; /* color of the scroll thumb */
    }
  }

  table {
    width : 100%;
    position: relative;
    border-collapse: collapse;
    border-spacing: 0;
    text-align: left;
  }

  thead {
    position: sticky;
    top: 0;
    background-color: $complementary-gray-2;
    font-size: 10px;
    color: $complementary-white-50;

    &::after {
      content: "";
      position: absolute;
      bottom: 10px;
      width: 100%;
      height: 1px;
      background-color: $complementary-white-50;
    }
  }

  tbody {
    tr {
      color: $complementary-white;
      &:hover {
        background-color: $complementary-white-5;
      }
    }
  }

  tr {
    height: 54px;
  }
</style>
